<template>
  <div class="flex justify-center q-my-xl">
    <q-btn
      class="btn-lg text-white bg-negative"
      unelevated
      label="Request to Delete Account"
      size="lg"
      style="font-size: 14px; font-weight: 700"
      @click="showRequestDialog = true"
    />
  </div>

  <!-- DIALOG: REQUEST TO DELETE -->
  <q-dialog
    v-model="showRequestDialog"
    persistent
    @hide="showRequestDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Request to Delete Account</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-mt-md q-mb-xl" style="font-size: 15px">
        • Your profile will be permanently deleted
      </q-card-section>

      <div class="q-my-md" align="center">
        <q-btn
          class="btn-lg text-white bg-negative"
          unelevated
          label="Request to Delete Account"
          size="lg"
          style="font-size: 14px; font-weight: 700"
          @click="requestDetele()"
          :loading="loading"
        />
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { DeleteAccountApi } from "src/hooks/api";
import useNotification from "src/hooks/notification";
import { defineComponent, ref } from "vue";
import { getErrorMessage } from "src/hooks/errorMessage";

export default defineComponent({
  name: "DeleteAccount",
  setup() {
    const { showNotif } = useNotification();
    const showRequestDialog = ref(false);
    const loading = ref(false);

    const requestDetele = async () => {
      console.log("requestDetele");
      loading.value = true;

      await DeleteAccountApi.request()
        .then((response) => {
          console.log("response: ", response);
          loading.value = false;
          showRequestDialog.value = false;
          showNotif({
            message: "Request has been successfully sent",
            color: "positive",
            position: "bottom-right",
          });
        })
        .catch((error) => {
          loading.value = false;
          showRequestDialog.value = false;
          showNotif({
            message: getErrorMessage(error),
            color: "negative",
            position: "bottom-right",
          });
        });
    };

    return {
      showRequestDialog,
      requestDetele,
      loading,
    };
  },
});
</script>
